/* $Id: arith_test.c,v 1.3 2007/02/20 14:48:06 dw Exp $ */
/* Copyright (c) Damian Weber <dweber@htw-saarland.de> */
/* License: BSD-style
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <stdio.h>
#include "f2npoly.h"

#define BUFFER_LENGTH 100000

int main(int argc, char **argv)
{
	f2poly_t f,g,h,q,r;
	char buffer[BUFFER_LENGTH];
	int i;
	
	if (argc<=1)
		return 1;
	
	init_poly(&f);
	init_poly(&g);
	init_poly(&h);
	init_poly(&q);
	init_poly(&r);
	to_f2poly(&f,argv[1]);
#if 0
	for (i=1;i<=40;i++)
	{
		mul_by_X(&f);
		to_string(buffer,&f);
		printf("$ f(X)*X^%d=%s\n",i,buffer);
	}
#endif	
	to_f2poly(&g,argv[2]);
	to_string(buffer,&f);
	printf("f(X)=%s\n",buffer);
	to_string(buffer,&g);
	printf("g(X)=%s\n",buffer);
	add(&h,&f,&g);
	to_string(buffer,&h);
	printf("f+g=%s \n",buffer);
	mul(&h,&f,&g);
	to_string(buffer,&h);
	printf("f*g=%s \n",buffer);
	puts(buffer);
	div_rem(&q,&r,&f,&g);
	to_string(buffer,&q);
	printf("q(X)=%s\n",buffer);
	to_string(buffer,&r);
	printf("r(X)=%s\n",buffer);
	mul(&h,&q,&g);
	add(&h,&h,&r);
	to_string(buffer,&h);
	printf("f(X)=%s (check)\n",buffer);
	add(&h,&f,&h);
	to_string(buffer,&h);
	printf("%s (final check)\n",buffer);
#if 1
	for (i=1;i<=4;i++)
	{
		power(&h,&f,i);
		to_string(buffer,&h);
		printf("$ f(X)^%d=%s\n",i,buffer);
	}
#endif
	gcd(&h,&f,&g);
	to_string(buffer,&h);
	printf("gcd(f,g)=%s\n",buffer);

	return 0;
}
